diff -uNrd ircd-ratbox-1.3-1/src/s_serv.c BgChat-Ircd/src/s_serv.c
--- ircd-ratbox-1.3-1/src/s_serv.c	Mon Dec  1 16:00:09 2003
+++ BgChat-Ircd/src/s_serv.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_serv.c: Server related functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_serv.c,v 7.333.2.6 2003/12/01 21:00:09 androsyn Exp $
+ *  $Id: s_serv.c,v 7.333.2.6 2004/02/03 21:00:09 MaskBg Exp $
  */
 
 #include "stdinc.h"
@@ -73,6 +72,14 @@
 int MaxClientCount = 1;
 int refresh_user_links = 0;
 
+int CurrentIdentUsers  = 0;
+int MaxIdentUsers  = 0;
+int CurrentOSidUsers = 0;
+int MaxOSidUsers = 0;
+int CurrentGlinerUsers = 0;
+int MaxGlinerUsers = 0;
+
+
 static void start_io(struct Client *server);
 
 static SlinkRplHnd slink_error;
@@ -781,6 +788,9 @@
 sendnick_TS(struct Client *client_p, struct Client *target_p)
 {
 	static char ubuf[12];
+    dlink_node *nchptr;
+    struct Channel * chptr;
+
 
 	if(!IsPerson(target_p))
 		return;
@@ -799,6 +809,21 @@
 			   ubuf,
 			   target_p->username, target_p->host,
 			   target_p->user->server, target_p->info);
+
+		if (IsNSId(target_p))
+			sendto_one(client_p, "SVSHINT NSID %s 1", target_p->name);
+
+        if (IsOSId(target_p))
+	        sendto_one(client_p, "SVSHINT OSID %s 1", target_p->name);
+
+        if (IsGLId(target_p))
+		    sendto_one(client_p, "SVSHINT NK %s 1", target_p->name);
+
+		DLINK_FOREACH(nchptr,target_p->user->nokick.head)
+	    {
+			chptr = nchptr->data;
+			sendto_one(client_p,"SVSHINT NOKICK %s %s 1",target_p->name,chptr->chname);
+	    }
 }
 
 /*
diff -uNrd ircd-ratbox-1.3-1/src/s_stats.c BgChat-Ircd/src/s_stats.c
--- ircd-ratbox-1.3-1/src/s_stats.c	Thu Jun 26 10:03:20 2003
+++ BgChat-Ircd/src/s_stats.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_stats.c: Statistics related functions
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_stats.c,v 7.27.2.1 2003/06/26 14:03:20 androsyn Exp $
+ *  $Id: s_stats.c,v 7.27.2.1 2004/02/10 14:03:20 MaskBg Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/s_user.c BgChat-Ircd/src/s_user.c
--- ircd-ratbox-1.3-1/src/s_user.c	Thu Dec  4 15:30:38 2003
+++ BgChat-Ircd/src/s_user.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_user.c: User related functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_user.c,v 7.266.2.6 2003/12/04 20:30:38 androsyn Exp $
+ *  $Id: s_user.c,v 7.266.2.6 2003/12/04 20:30:38 MaskBg Exp $
  */
 
 #include "stdinc.h"
@@ -92,6 +91,9 @@
 	{UMODE_EXTERNAL, 'x'},
 	{UMODE_SPY, 'y'},
 	{UMODE_OPERWALL, 'z'},
+	{FLAGS_SILENCE, 'S'},
+    {FLAGS_TRANSWIN, 'T'},
+	{FLAGS_TRANSISO, 'Y'},
 	{UMODE_OPERSPY, 'Z'},
 	{0, 0}
 };
@@ -122,13 +124,13 @@
 	0,			/* P */
 	0,			/* Q */
 	0,			/* R */
-	0,			/* S */
-	0,			/* T */
+    FLAGS_SILENCE,		/* S */
+	FLAGS_TRANSWIN,		/* T */
 	0,			/* U */
 	0,			/* V */
 	0,			/* W */
 	0,			/* X */
-	0,			/* Y */
+    FLAGS_TRANSISO, 	/* Y */
 	UMODE_OPERSPY,		/* Z 0x5A */
 	0, 0, 0, 0, 0,		/* 0x5F */
 	/* 0x60 */ 0,
@@ -215,6 +217,16 @@
 	sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, source_p->name,
 		   Count.total, Count.max_tot);
 
+    sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, source_p->name,
+             CurrentIdentUsers, MaxIdentUsers);
+
+    sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, source_p->name,
+             CurrentOSidUsers, MaxOSidUsers);
+
+    sendto_one(source_p, form_str(RPL_GLIDUSERS), me.name, source_p->name,
+             CurrentGlinerUsers, MaxGlinerUsers);
+
+
 	if(!ConfigServerHide.hide_servers || IsOper(source_p))
 		sendto_one(source_p, form_str(RPL_STATSCONN), me.name, source_p->name,
 			   MaxConnectionCount, MaxClientCount, Count.totalrestartcount);
@@ -1026,6 +1038,14 @@
 				break;
 			}
 
+
+	if (MyConnect(source_p) && !(setflags & FLAGS_SILENCE) && (HasSilence(source_p)))
+	{
+	    sendto_one(source_p,":%s NOTICE %s :You have put Silence mode on your nickname (+S). You will NOT receive any private messages, ctcps, notices from unregistered (too recently registered) nicknames",
+				   me.name, parv[0]);
+	}
+
+
 	if(badflag)
 		sendto_one(source_p, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
 
@@ -1152,6 +1172,8 @@
 void
 user_welcome(struct Client *source_p)
 {
+  struct Client * cptr;
+
 	sendto_one(source_p, form_str(RPL_WELCOME), me.name, source_p->name,
 		   ServerInfo.network_name, source_p->name);
 	sendto_one(source_p, form_str(RPL_YOURHOST), me.name, source_p->name,
@@ -1183,6 +1205,13 @@
 	}
 	else
 		SendMessageFile(source_p, &ConfigFileEntry.motd);
+
+
+	if (!(cptr = find_client("OS")) || !(cptr = find_client("CS"))) {
+		sendto_one(source_p, "NOTICE %s :*** Notice -- Services [CS,NS,MS,OS,Info] Down!",
+				   source_p->name);
+	}
+
 
 	if(IsRestricted(source_p))
 	{
diff -uNrd ircd-ratbox-1.3-1/src/scache.c BgChat-Ircd/src/scache.c
--- ircd-ratbox-1.3-1/src/scache.c	Thu Jun 26 10:03:20 2003
+++ BgChat-Ircd/src/scache.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  scache.c: Server names cache.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
diff -uNrd ircd-ratbox-1.3-1/src/send.c BgChat-Ircd/src/send.c
--- ircd-ratbox-1.3-1/src/send.c	Mon Dec  1 16:00:10 2003
+++ BgChat-Ircd/src/send.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  send.c: Functions for sending messages.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: send.c,v 7.246.2.7 2003/12/01 21:00:10 androsyn Exp $
+ *  $Id: send.c,v 7.246.2.7 2004/02/01 21:00:10 MaskBg Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/snprintf.c BgChat-Ircd/src/snprintf.c
--- ircd-ratbox-1.3-1/src/snprintf.c	Thu Jun 26 10:03:20 2003
+++ BgChat-Ircd/src/snprintf.c	Mon Mar 29 07:17:51 2004
@@ -1,9 +1,8 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  snprintf.c: Functions for printing to a length-limited string.
  *
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  Also one should have a look at the original header from mutt.  99%
  *  of the code is original from there...
diff -uNrd ircd-ratbox-1.3-1/src/tools.c BgChat-Ircd/src/tools.c
--- ircd-ratbox-1.3-1/src/tools.c	Wed Sep  3 12:46:29 2003
+++ BgChat-Ircd/src/tools.c	Mon Mar 29 07:17:51 2004
@@ -1,9 +1,8 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  tools.c: Various functions needed here and there.
  *
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -20,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: tools.c,v 7.38.2.2 2003/09/03 16:46:29 leeh Exp $
+ *  $Id: tools.c,v 7.38.2.2 2004/02/02 16:46:29 MaskBg Exp $
  *
  *  Here is the original header:
  *
diff -uNrd ircd-ratbox-1.3-1/src/version.c.SH BgChat-Ircd/src/version.c.SH
--- ircd-ratbox-1.3-1/src/version.c.SH	Sun Jul  6 11:01:03 2003
+++ BgChat-Ircd/src/version.c.SH	Mon Mar 29 07:17:51 2004
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-# $Id: version.c.SH,v 7.25.4.2 2003/07/06 15:01:03 leeh Exp $ 
+# $Id: version.c.SH,v 7.25.4.2 2004/02/09 15:01:03 MaskBg Exp $ 
 
 spitshell=cat
 package=IRC
diff -uNrd ircd-ratbox-1.3-1/src/whowas.c BgChat-Ircd/src/whowas.c
--- ircd-ratbox-1.3-1/src/whowas.c	Thu Jun 26 10:03:21 2003
+++ BgChat-Ircd/src/whowas.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  whowas.c: WHOWAS user cache.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: whowas.c,v 7.27.2.1 2003/06/26 14:03:21 androsyn Exp $
+ *  $Id: whowas.c,v 7.27.2.1 2004/02/05 14:03:21 MaskBg Exp $
  */
 
 #include "stdinc.h"
